/* Copyright 2004 Jetro Lauha - http://iki.fi/jetro/
 *
 * $Id: testlevel.as,v 1.7 2004/08/05 01:21:31 tonic Exp $
 * $Revision: 1.7 $
 */

/* Note: playSound function is undocumented as it is currently
 *       only temporarily as it is.
 */


int screenWidth, screenHeight;
uint frame = 0;

int score = 0;

GameApp *app;
UIFont *medFont, *smallFont;
uint medFontHeight, smallFontHeight;
PhysicsWorld *pw;

PhysicsObject *objHead, *objNeck, *objTrunk, *objRthigh, *objLthigh, *objRcalf, *objLcalf, *objRfore, *objLfore, *objLarm, *objRarm, *objRfoot, *objLfoot;
float objTrunkPosX, objTrunkPosY, objTrunkPosZ;

PhysicsObject *objBlok, *objBlok2;
float objBlokPosX, objBlokPosY, objBlokPosZ; 
float objBlok2PosX, objBlok2PosY, objBlok2PosZ;

float afstandtotblok1, afstandtotblok2, afstandBlokX, afstandBlokY, afstandBlokZ,
                                        afstandBlok2X, afstandBlok2Y, afstandBlok2Z; 

bool finished = false;
bool aborted = false;


// Called once on level initialization.
void onInit()
{
    app = getGameApp();
    app->setClearColor(0, 0.7, 1.0);

    screenWidth = app->getScreenWidth();
    screenHeight = app->getScreenHeight();
    medFont = app->getFont("medium");
    smallFont = app->getFont("small");
    medFontHeight = medFont->getFontHeight();
    smallFontHeight = smallFont->getFontHeight();

    pw = app->getPhysicsWorld();
    pw->setGravity(0, 0, -0.5);

    // Ragdoll head
    objHead = pw->findObject("Head");
    objNeck = pw->findObject("Neck");
    objTrunk = pw->findObject("Trunk");
    objRthigh = pw->findObject("RightThigh");
    objLthigh = pw->findObject("LeftThigh");
    objRarm = pw->findObject("RightArm");
    objLarm = pw->findObject("LeftArm");
    objRfore = pw->findObject("RightForearm");
    objLfore = pw->findObject("LeftForearm");
    objRcalf = pw->findObject("RightCalf");
    objLcalf = pw->findObject("LeftCalf");
    objRfoot = pw->findObject("RightFoot");
    objLfoot = pw->findObject("LeftFoot");

    objBlok = pw->findObject("blok");
    objBlok2 = pw->findObject("blok2");

    objBlok->getPosition(objBlokPosX, objBlokPosY, objBlokPosZ); 
    objBlok2->getPosition(objBlok2PosX, objBlok2PosY, objBlok2PosZ); 


    revertColors();

}

void revertColors()
{

    objHead->setColor(1.00000, 0.562500, 0.385417);
    objNeck->setColor(1.00000, 0.562500, 0.385417);
    objTrunk->setColor(0.250000, 0.562500, 1.00000);
    objRthigh->setColor(0.00000, 1.000000, 0.00000);
    objLthigh->setColor(0.00000, 1.000000, 0.00000);
    objRarm->setColor(0.250000, 0.562500, 1.00000);
    objLarm->setColor(0.250000, 0.562500, 1.00000);
    objRfore->setColor(1.00000, 0.562500, 0.385417);
    objLfore->setColor(1.00000, 0.562500, 0.385417);
    objRcalf->setColor(1.00000, 0.562500, 0.385417);
    objLcalf->setColor(1.00000, 0.562500, 0.385417);
    objRfoot->setColor(1.00000, 1.00000, 0.270833);
    objLfoot->setColor(1.00000, 1.00000, 0.270833);
		
}


// Called once for each game logic update before the physics update.
// Parameter 'time' is the simulation time in milliseconds.
void onUpdate(uint time)
{
    ++frame;

    objTrunk->getPosition(objTrunkPosX, objTrunkPosY, objTrunkPosZ);

    if (objTrunkPosX - objBlokPosX < 0)
	afstandBlokX = 0 - (objTrunkPosX - objBlokPosX);
    else
	afstandBlokX = 0 + (objTrunkPosX - objBlokPosX); 
    
    if (objTrunkPosY - objBlokPosY < 0)
	afstandBlokY = 0 - (objTrunkPosY - objBlokPosY);
    else
	afstandBlokY = 0 + (objTrunkPosY - objBlokPosY);
    
    if (objTrunkPosZ - objBlokPosZ < 0)
	afstandBlokZ = 0 - (objTrunkPosZ - objBlokPosZ);
    else
	afstandBlokZ = 0 + (objTrunkPosZ - objBlokPosZ);  


    if (objTrunkPosX - objBlok2PosX < 0)
	afstandBlok2X = 0 - (objTrunkPosX - objBlok2PosX);
    else
	afstandBlok2X = 0 + (objTrunkPosX - objBlok2PosX); 
    
    if (objTrunkPosY - objBlok2PosY < 0)
	afstandBlok2Y = 0 - (objTrunkPosY - objBlok2PosY);
    else
	afstandBlok2Y = 0 + (objTrunkPosY - objBlok2PosY);
    
    if (objTrunkPosZ - objBlok2PosZ < 0)
	afstandBlok2Z = 0 - (objTrunkPosZ - objBlok2PosZ);
    else
	afstandBlok2Z = 0 + (objTrunkPosZ - objBlok2PosZ);  

    afstandtotblok1 = (afstandBlokX + afstandBlokY + afstandBlokZ);
    afstandtotblok2 = (afstandBlok2X + afstandBlok2Y + afstandBlok2Z);
    


    if (afstandtotblok1 > (1.5f * afstandtotblok2))
    {
	pw->setGravity(-0.25f * (objTrunkPosX - objBlokPosX),
   	               -0.25f * (objTrunkPosY - objBlokPosY),
		       -0.25f * (objTrunkPosZ - objBlokPosZ));
    }
    else if (afstandtotblok2 > (1.5f * afstandtotblok1))
    {
	pw->setGravity(-0.25f * (objTrunkPosX - objBlok2PosX),
   	               -0.25f * (objTrunkPosY - objBlok2PosY),
		       -0.25f * (objTrunkPosZ - objBlok2PosZ)); 
    }
          

    revertColors();

}


// Called when there is a collision between the two given objects.
// Returns true to create contacts or false to ignore collision.
bool onCollision(PhysicsObject *o1, PhysicsObject *o2)
{

    if (o1->getType() == PHYSOBJ_RAGDOLL_BODY) o1->setColor(1,0,0);
    if (o2->getType() == PHYSOBJ_RAGDOLL_BODY) o2->setColor(1,0,0);

    
    // generate collision
    return true;
}


// Called when the game view is rendered.
// Might happen more or less frequently than update calls.
void onRender()
{
    const float gap = 70;


    // draw score
    const float x = float(screenWidth) - gap;
    medFont->drawString(x, gap, UIFONT_ALIGN_RIGHT, bstrFormat(score));
    smallFont->drawString(x, gap + float(medFontHeight),
                          UIFONT_ALIGN_RIGHT, "Score");

    medFont->drawString(x, 1.5f * gap, UIFONT_ALIGN_RIGHT, bstrFormat(afstandtotblok1));
    medFont->drawString(x, 2.0f * gap, UIFONT_ALIGN_RIGHT, bstrFormat(afstandtotblok2));
    


    if (aborted)
        drawFailure();
    if (finished)
        drawVictory();
}



void drawFailure()
{
    medFont->drawString(float(screenWidth / 2), float(screenHeight / 2),
                        UIFONT_ALIGN_HORIZ_CENTER | UIFONT_ALIGN_VERT_CENTER,
                        "You Failed!");
}


void drawVictory()
{
    medFont->drawString(float(screenWidth / 2), float(screenHeight / 2),
                        UIFONT_ALIGN_HORIZ_CENTER | UIFONT_ALIGN_VERT_CENTER,
                        "Victory!");
    
    medFont->drawString(float(screenWidth / 2),
                        float(screenHeight / 2 + int(medFontHeight) * 5),
                        UIFONT_ALIGN_HORIZ_CENTER | UIFONT_ALIGN_VERT_CENTER,
                        "Total score: " + bstrFormat(score));
}
